; 
 ;     .686p                       ; create 32 bit code
 ;     
 ;     .model flat, stdcall       ; 32 bit memory model
 ;     option casemap :none       ; case sensitive
 ;  
 ;     include \masm32\include\windows.inc
 ;     include \masm32\include\masm32.inc
 ;     include \masm32\include\kernel32.inc
 ;     include \masm32\include\msvcrt.inc
 ; 
 ;     includelib \masm32\lib\masm32.lib
 ;     includelib \masm32\lib\kernel32.lib
 ;     includelib \masm32\lib\msvcrt.lib
 ; 
 ;     include \masm32\macros\macros.asm
 ;     include \masm32\include\timers.asm
 ;  
    include \masm32\include\masm32rt.inc

    StrComp     PROTO :DWORD,:DWORD,:DWORD
    _szCmp_new  PROTO :DWORD,:DWORD
    dcmp        PROTO :DWORD,:DWORD,:DWORD
    szMidW      PROTO :DWORD,:DWORD,:DWORD,:DWORD

;---------------------------------------------------------------------------
PRECHECK = 0           ; 0 = precheck  , 1 = NO precheck
;---------------------------------------------------------------------------

    .data
      strA db "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"      
           db "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"
           db "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"
           db "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"
           db 0,0,0,0
;align 4           
      strB db "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"
           db "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"
           db "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"
           db "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"      
           db 0,0,0,0
      i dd 0
      Mism db 1,0,0,0
    .code


start:
   
; 

    call main
    inkey
    exit

; 

main proc
    cls
    print chr$("Comparing strings ",13,10)

    print chr$(" Mm  DWORD dcmp  szCmp",13,10)  
    mov i, 0
    .repeat      
;############################################################
; Matching Strings of length i
;############################################################
      print chr$(" i=")
      print ustr$(i)      
      print chr$("   ")

      invoke MemCopy, ADDR strB, ADDR strA, 200
      invoke szMidW, ADDR strA, ADDR Mism, i, 1        ; create mismatch at offset i

      counter_begin 1000000, REALTIME_PRIORITY_CLASS
      invoke StrComp, ADDR strA, ADDR strB, 200
      counter_end
      print ustr$(eax), "    "      

      counter_begin 1000000, REALTIME_PRIORITY_CLASS
      invoke dcmp, ADDR strA, ADDR strB, 200
      counter_end      
      print ustr$(eax), "     "

      counter_begin 1000000, REALTIME_PRIORITY_CLASS
      invoke _szCmp_new, ADDR strA, ADDR strB
      counter_end
      print ustr$(eax), "     "      

      print " ", 13, 10    
;############################################################

       add i , 4
    .until i > 100

    ret
main endp
; 


OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

dcmp proc src:DWORD,dst:DWORD,ln:DWORD

    mov eax, [esp+4]        ; src
    mov edx, [esp+8]        ; dst


;------------- check first character -------------
IFE PRECHECK
    mov cl, byte ptr[eax]
    cmp cl, byte ptr[edx]
    je @F
     .if cl < byte ptr[edx]
       mov eax, dword ptr[-1]
     .else
       mov eax, 1
     .endif
    ret 12
ENDIF
;------------- check first character -------------

@@:
    mov ecx, [esp+12]       ; ln
        
    shr ecx, 3

    push ebx
    push esi
    push edi
    push ebp

    cmp DWORD PTR [esp+12+16], 8    ; if length < 8
    jl tlin

  @@:
  REPEAT 3
    mov ebx, [eax]
    mov esi, [eax+4]
    mov edi, [edx]
    mov ebp, [edx+4]
    cmp ebx, edi
    jne fail0
    cmp esi, ebp
    jne fail1
    add eax, 8
    add edx, 8
    sub ecx, 1
    jz tail
  ENDM

    mov ebx, [eax]
    mov esi, [eax+4]
    mov edi, [edx]
    mov ebp, [edx+4]
    cmp ebx, edi
    jne fail0
    cmp esi, ebp
    jne fail1
    add eax, 8
    add edx, 8
    sub ecx, 1
    jnz @B

  tail:
    mov ecx, [esp+12+16]    ; reload length
    and ecx, 4
    jz ok

  tlin:
    xor esi, esi

  @@:
    movzx ebx, BYTE PTR [eax+esi]
    cmp bl, [edx+esi]
    jne fail2
    add esi, 1
    sub ecx, 1
    jnz @B

  ok:
    mov eax, 0          ; return ZERO on match    
    pop ebp
    pop edi
    pop esi
    pop ebx
    ret 12

  fail0:
    bswap ebx
    bswap edi
    .if ebx < edi
        mov eax, dword ptr[-1]
    .else
        mov eax, 1
    .endif
    pop ebp
    pop edi
    pop esi
    pop ebx
    ret 12

  fail1:
    bswap esi 
    bswap ebp
    .if esi < ebp
        mov eax, dword ptr[-1]
    .else
        mov eax, 1
    .endif
    pop ebp
    pop edi
    pop esi
    pop ebx
    ret 12

  fail2:
     .if bl < byte ptr[edx+esi]
       mov eax, dword ptr[-1]
     .else
       mov eax, 1
     .endif

  finish:
    pop ebp
    pop edi
    pop esi
    pop ebx
    ret 12

dcmp endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

align 16
  ; --------------------------------------
  ; scan string for match
  ; Returning 0   : Match
  ;           1   ; str1 > str2
  ;          -1   ; str1 < str2
  ; --------------------------------------

;#######################################################################
;  DWORD-wise 
;#######################################################################
StrComp proc uses edi, str1:DWORD, str2:DWORD, strlen:dword
    mov ecx, str1
    mov edx, str2
    mov edi, strlen
        
;------------- check first character -------------
IFE PRECHECK
    mov al, [ecx]                
    cmp al, byte ptr [edx]
    jne no_match2
ENDIF
;------------- check first character -------------
  
    shr edi, 2
    .while edi > 0
        mov eax, [ecx]
        cmp eax, [edx]
        jne no_match1
        add edx, 4
        add ecx, 4        
        dec edi
    .endw    
    mov edi, strlen
    and edi, 3
    .while edi > 0
        mov al, [ecx]
        cmp al, byte ptr [edx]
        jne no_match2
        add edx, 1
        add ecx, 1        
        dec edi
    .endw
    
    xor eax, eax
    ret

  no_match2:
      .if al < byte ptr[edx]
        mov eax, dword ptr[-1]
      .else
        mov eax, 1
      .endif
      ret

  no_match1:
      mov ecx, [edx]
      bswap eax             ; to get the right byte-order !
      bswap ecx
      .if eax < ecx
        mov eax, dword ptr[-1]
      .else
        mov eax, 1
      .endif
      ret
  
StrComp endp

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

_szCmp_new proc str1:DWORD, str2:DWORD

  ; --------------------------------------
  ; scan zero terminated string for match
  ; --------------------------------------
    mov ecx, [esp+4]
    mov edx, [esp+8]

    push ebx
    push esi
    mov eax, -1
    mov esi, 1

  align 4
  cmst:
  REPEAT 3
    add eax, esi
    movzx ebx, BYTE PTR [ecx+eax]
    cmp bl, [edx+eax]
    jne no_match
    test ebx, ebx       ; check for terminator
    je retlen
  ENDM

    add eax, esi
    movzx ebx, BYTE PTR [ecx+eax]
    cmp bl, [edx+eax]
    jne no_match
    test ebx, ebx       ; check for terminator
    jne cmst

  retlen:               ; length is in EAX
    pop esi
    pop ebx
    ret 8
  no_match:
     .if bl < byte ptr[edx+eax]
       mov eax, dword ptr[-1]
     .else
       mov eax, 1
     .endif
    pop esi
    pop ebx
    ret 8

_szCmp_new endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 


align 4
; Writes ln bytes from src to dst starting at stp    

szMidW proc dst:DWORD,src:DWORD,stp:DWORD,ln:DWORD

    push edi

    mov ecx, ln             ; length in ECX
    mov edx, dst            ; source address
    add edx, ecx            ; add required length
    add edx, stp            ; add starting position
    mov edi, src            ; destination address
    add edi, ecx            ; add length and set terminator position
    neg ecx                 ; invert sign

  @@:
    mov al, [edi+ecx]
    mov [edx+ecx], al
    add ecx, 1
    jnz @B
    pop edi

    ret

szMidW endp


end start
